<!DOCTYPE html>
<html>
   <head>
      <meta charset="utf-8">
      <style>
        #content {
            white-space: pre-line;
        }
      </style>
   </head>
   <body>
      <p><button id="stopButton">Stop Listening</button></p>
      <div id="content"></div>
      <script>
        const content = document.getElementById('content');
         const source = new EventSource('/sse');
         source.addEventListener('open', () => content.textContent += 'Connection established..\n');
         source.addEventListener('test', e => {
            console.log(e);
            content.textContent += `test event: ${e.data}\n`;
         });
         source.onmessage = e => {
            console.log(e);
            content.textContent += e.data + '\n';
         };
         document.getElementById('stopButton').addEventListener('click', e => {
            content.textContent += 'Connection closed...\n';
            source.close();
         });
      </script>
   </body>
</html>